-- stuff such as the mouse, position etc, anything that can be related in any way to the local player

local t = {}

t.updatePosR = function() -- breaks up the screen into 9 portions, checks in what portion the mouse is, then based on the result it updates the pos r
      if (mouseX < wW / 2 - 150) and (mouseY < wH / 2 + 150) and (mouseY > wH / 2 - 150) then -- i forgot to mention its a huge if statement
        player.entity.pos.r = 1
  elseif (mouseX < wW / 2 - 150) and (mouseY < wH / 2 - 150) then
        player.entity.pos.r = 2
  elseif (mouseX > wW / 2 - 150) and (mouseX < wW / 2 + 150) and (mouseY < wH / 2 - 150) then
        player.entity.pos.r = 3
  elseif (mouseX > wW / 2 + 150) and (mouseY < wH / 2 - 150) then
        player.entity.pos.r = 4
  elseif (mouseX > wW / 2 + 150) and (mouseY < wH / 2 + 150) and (mouseY > wH / 2 - 150) then
        player.entity.pos.r = 5
  elseif (mouseX > wW / 2 + 150) and (mouseY > wH / 2 + 150) then
        player.entity.pos.r = 6
  elseif (mouseX < wW / 2 + 150) and (mouseX > wW / 2 - 150) and (mouseY > wH / 2 + 150) then
        player.entity.pos.r = 7
  elseif (mouseX < wW / 2 - 150) and (mouseY > wH / 2 + 150) then
        player.entity.pos.r = 8
  end
end

t.camZoom = function()
  function love.wheelmoved(x,y)
    if (zoom + (y / 20)) <= 0.1 then
      zoom = 0.1
    elseif (zoom + (y / 20)) >= 2 then
      zoom = 2
    else
      zoom = zoom + (y / 20)
    end
  end
end

t.playerMove = function(x,y)
    if gridFuncs.gridCheck(player.entity.pos.x + x,player.entity.pos.y + y,player.entity.pos.z,0,true) then
      player.entity.pos.x = player.entity.pos.x + x
      player.entity.pos.y = player.entity.pos.y + y
      if gridFuncs.gridCheck(player.entity.pos.x,player.entity.pos.y,player.entity.pos.z - 1,0,false) then
        audio.sounds[1]:play()
      end
      player.data.canMove = false
      player.data.moveTimer:after(0.4 / player.entity.stats.speed,function() player.data.canMove = true end)
    end
end

t.playerJump = function(z)
  if player.data.canJump and (not player.data.jumping) then
    if gridFuncs.gridCheck(player.entity.pos.x,player.entity.pos.y,player.entity.pos.z + 1,0,true) then
      for i=1,z do
        if gridFuncs.gridCheck(player.entity.pos.x,player.entity.pos.y,player.entity.pos.z + 1,0,true) then
          player.entity.pos.z = player.entity.pos.z + 1
        end
      end
      audio.sounds[2]:play()
      player.data.jumping = true
      player.data.canJump = false
      player.data.jumpTimer:after(0.3 ,function() player.data.jumping = false end)
    end
  end
end

t.globalMovement = function()
  if love.keyboard.isDown('w') then
    if player.data.canMove then
      clientFuncs.playerMove(-1,0)
    end
  elseif love.keyboard.isDown('s') then
    if player.data.canMove then
      clientFuncs.playerMove(1,0)
    end
  end
  if love.keyboard.isDown('a') then
    if player.data.canMove then
      clientFuncs.playerMove(0,-1)
    end
  elseif love.keyboard.isDown('d') then
    if player.data.canMove then
      clientFuncs.playerMove(0,1)
    end
  end
end

t.relativeMovement = function() -- tbd

end

t.jump = function()
  function love.keypressed(key,scancode)
    if scancode == 'space' then
      clientFuncs.playerJump(2)
    end
  end
end

t.gravity = function()
  if not player.data.jumping then
    if gridFuncs.gridCheck(player.entity.pos.x,player.entity.pos.y,player.entity.pos.z - 1,0,true) then
      player.entity.pos.z = player.entity.pos.z - 1
    end
  end
end

t.mineAndBuild = function()
  function love.mousepressed(x,y,button)
    if button == 1 then
      if player.entity.pos.r == 1 then
        gridFuncs.lowestCube(player.entity.pos.x + 1,player.entity.pos.y - 1,player.entity.pos.z,0,0,-1,false)
      end
      if player.entity.pos.r == 2 then
        gridFuncs.lowestCube(player.entity.pos.x,player.entity.pos.y - 1,player.entity.pos.z,0,0,-1,false)
      end
      if player.entity.pos.r == 3 then
        gridFuncs.lowestCube(player.entity.pos.x - 1,player.entity.pos.y - 1,player.entity.pos.z,0,0,-1,false)
      end
      if player.entity.pos.r == 4 then
        gridFuncs.lowestCube(player.entity.pos.x - 1,player.entity.pos.y,player.entity.pos.z,0,0,-1,false)
      end
      if player.entity.pos.r == 5 then
        gridFuncs.lowestCube(player.entity.pos.x - 1,player.entity.pos.y + 1,player.entity.pos.z,0,0,-1,false)
      end
      if player.entity.pos.r == 6 then
        gridFuncs.lowestCube(player.entity.pos.x,player.entity.pos.y + 1,player.entity.pos.z,0,0,-1,false)
      end
      if player.entity.pos.r == 7 then
        gridFuncs.lowestCube(player.entity.pos.x + 1,player.entity.pos.y + 1,player.entity.pos.z,0,0,-1,false)
      end
      if player.entity.pos.r == 8 then
        gridFuncs.lowestCube(player.entity.pos.x + 1,player.entity.pos.y,player.entity.pos.z,0,0,-1,false)
      end
    elseif button == 2 then
      if player.entity.pos.r == 1 then
        gridFuncs.highestCube(player.entity.pos.x + 1,player.entity.pos.y - 1,player.entity.pos.z,3,-1,1,true)
      end
      if player.entity.pos.r == 2 then
        gridFuncs.highestCube(player.entity.pos.x,player.entity.pos.y - 1,player.entity.pos.z,3,-1,1,true)
      end
      if player.entity.pos.r == 3 then
        gridFuncs.highestCube(player.entity.pos.x - 1,player.entity.pos.y - 1,player.entity.pos.z,3,-1,1,true)
      end
      if player.entity.pos.r == 4 then
        gridFuncs.highestCube(player.entity.pos.x - 1,player.entity.pos.y,player.entity.pos.z,3,-1,1,true)
      end
      if player.entity.pos.r == 5 then
        gridFuncs.highestCube(player.entity.pos.x - 1,player.entity.pos.y + 1,player.entity.pos.z,3,-1,1,true)
      end
      if player.entity.pos.r == 6 then
        gridFuncs.highestCube(player.entity.pos.x,player.entity.pos.y + 1,player.entity.pos.z,3,-1,1,true)
      end
      if player.entity.pos.r == 7 then
        gridFuncs.highestCube(player.entity.pos.x + 1,player.entity.pos.y + 1,player.entity.pos.z,3,-1,1,true)
      end
      if player.entity.pos.r == 8 then
        gridFuncs.highestCube(player.entity.pos.x + 1,player.entity.pos.y,player.entity.pos.z,3,-1,1,true)
      end
    end
  end
end

return t